// Data: 20/07/2021
// Prof. Dr. Jean M. Simo

//UNIVERSIDADE TECNOLGICA FEDERAL DO PARAN - Campus de Curitiba
//(Brasil) - Departamento Acadmico de Informtica (DAINF).

//Disciplina: Tcnicas de Programao

//#include <stdlib.h>  // funo abs
//#include <time.h>  // funcao time

#include <sys/time.h>
#include <tgmath.h>

#include <iostream>
#include <vector>
#include <list>
using namespace std;

#define MAX_MAT 30000
#define MAX_ANT 1000

#define DIV 30000

// Questo - 1

class Essencia
{
      protected:
              short int numero;
              float carga;

      public:
              Essencia(const short int num = -1, const float crg = 0.0):
                  numero(num),
                  carga(crg)
              {
                  //numero = num;
                  //carga = crg;

                  nao_zero(carga);
              }

              void nao_zero(float &crg) { if (0.0 == crg) { crg = 1.0; } } // Para garantir que carga seja diferente de zero

              virtual ~Essencia() { numero = carga = 0.0; }

              const short int getNumero() const { return (int)fabs(numero); }
              // retornando o mdulo aqui por interpretao no enunciado...

              void setCarga(const float crg)
              {
                  carga = crg;
                  nao_zero(carga);
              }

              const float getCarga() const { return (float)fabs(carga);  /* return abs(carga); */ }

              virtual const bool desalocavel() const = 0;   // Funo virtual pura
};

// Questo - 2

class Materia : public Essencia
{
  private:
          unsigned int carga_minima;

  public:
          Materia(const short int num = -1, const float crg = 0.0, const unsigned int cmin = 0):
              Essencia(num, crg),
              carga_minima(cmin)
          {

                if (carga < 0.0) { carga = carga * -1.0; }
                //if (carga_minima < 0) ( carga_minima = carga_minima -1 }
                if (0 == carga_minima) { carga_minima = 1; }
          }

          ~Materia() { carga_minima = 0; }

         // const unsigned int getCargaMinima() const { return carga_minima; }

          const bool desalocavel() const
          {
              if ( (getCarga()/2.0) < ( (float)carga_minima) )
              {
                  return true;
              }
              else
              {
                  return false;
              }
          }
};

// Questo - 3

class Antimateria  : public Essencia
{
  private:
          long int carga_maxima;

  public:
          Antimateria(const short int num = -1, const float crg = 0.0, const long int cmax = 1):
              Essencia(num, crg),
              carga_maxima(cmax)
          {
                if (carga > 0.0) { carga = carga * -1.0; }
                if (carga_maxima > 0) { carga_maxima = carga_maxima * -1; }
                if (0 == carga_maxima ) { carga_maxima = -1; }
          }

          ~Antimateria() { carga_maxima = 0; }

          //const long int getCargaMaxima() const { return carga_maxima; }

          const bool desalocavel() const
          {
              if ( carga >= ((float)carga_maxima) )
              {
                  return true;
              }
              else
              {
                  return false;
              }
          }
};

// Questo - 4

class GrupoEssencias
{
  private:
        list<Materia*>                  LMaterias;
        vector<Antimateria*>            LAntimaterias;

        list<Materia*>::iterator        itLM;
        vector<Antimateria*>::iterator  itLAM;

  public:
         GrupoEssencias() : LMaterias(), LAntimaterias(), itLM(), itLAM()
         {

         }

         ~GrupoEssencias()
         {
            cout << "Destrutora GrupoEsssencias." << endl;
            for ( itLM = LMaterias.begin();      itLM != LMaterias.end();       itLM++ )
            {
                if (*itLM)
                {
                    delete *itLM;
                    *itLM = NULL;
                }
            }
            LMaterias.clear();

            for ( itLAM = LAntimaterias.begin(); itLAM != LAntimaterias.end();  itLAM++)
            {
                if (*itLAM)
                {
                    delete *itLAM;
                    *itLAM = NULL;
                }
            }
            LAntimaterias.clear();
         }

         void incluirMateria(Materia* pM)
         {
                if (NULL != pM)
                {
                    LMaterias.push_back(pM);
                }
                else
                {
                    cout << "Ponteiro de matria nulo." << endl;
                }
         }

        void incluirAntimateria(Antimateria* pAM)
         {
                if (NULL != pAM)
                {
                    LAntimaterias.push_back(pAM);
                }
                else
                {
                    cout << "Ponteiro de antimatria nulo." << endl;
                }
         }

         void confrontarMateriaXAntimateria()
         {
//            list<Materia*>::const_iterator        itLM;
//            vector<Antimateria*>::const_iterator  itLAM;

             for (  itLM = LMaterias.begin();   itLM != LMaterias.end();    itLM++  )
             {
                 for (  itLAM = LAntimaterias.begin(); itLAM != LAntimaterias.end(); itLAM++)
                 {
                     if (  (*itLM) && (*itLAM) )
                     {
                        if ( (*itLM)->getNumero() == (*itLAM)->getNumero() )
                        {
                            cout << "ATENO - Houve coliso de matria e antimatria! "  << (*itLAM)->getNumero() << endl; //getchar();

                            float result1 = 0.0;
                            float result2 = 0.0;
                            result1 = (*itLM)->getCarga() - (*itLAM)->getCarga() ;
                            result2 = (*itLAM)->getCarga() - (*itLM)->getCarga() ;

                            cout << "Materia - carga: "  << (*itLM)->getCarga() << endl;
                            cout << "Antimateria - carga: "  << (*itLAM)->getCarga() << endl;
                            cout << "Resultado da coliso - Materia - Anti: "  << result1 << endl;
                            cout << "Resultado da coliso - Anti - Materia: "  << result2 << endl; //getchar();

                            if ( result1 > 0 )
                            {
                                (*itLM)->setCarga( result1 ) ;
                            }
                            else
                            {
                                (*itLM)->setCarga(1.0);
                            }

                            if ( result2 > 0 )
                            {
                                (*itLAM)->setCarga( -1.0 * result2 );
                            }
                            else
                            {
                                (*itLAM)->setCarga(1.0);
                            }
                            cout << endl;
                        }
                    }
                 }
             }
         }

         void desalocar()
         {
              // erase -  https://www.ti-enxame.com/pt/c%2B%2B/como-apago-elementos-de-conteineres-stl/1072237061/
              // remove - https://www.cplusplus.com/reference/list/list/remove/
              // remove - https://en.cppreference.com/w/cpp/algorithm/remove

              //list<Materia*>::iterator        itLM;
              //vector<Antimateria*>::iterator  itLAM;

              cout << "Passo 1 - desalocao de Materias: " << endl; getchar();
              int cont = 0;
              for ( itLM = LMaterias.begin(); itLM != LMaterias.end(); )
              {
                  if ( (*itLM) && ((*itLM)->desalocavel()) )
                  {
                        delete *itLM;
                        *itLM = NULL;
                        itLM = LMaterias.erase(itLM);

                        cont++;
                        cout  << "Quantidade de elementos em LM: " << (int)LMaterias.size() << endl; //getchar();
                  }
                  else
                  {
                    itLM++;
                  }
              }
              cout << "Quantidade de matria desalocada: " << cont << endl;

              cout << "Passo 2 - desalocao de Antimarerias: " << endl; getchar();
              cont = 0;
              for (itLAM = LAntimaterias.begin(); itLAM != LAntimaterias.end(); )
              {
                  if ( (*itLAM) && ( (*itLAM)->desalocavel() ) )
                  {
                     delete *itLAM;
                     *itLAM=NULL;
                     itLAM = LAntimaterias.erase(itLAM);
                     cont++;
                     cout  << "Quantidade de elementos em LAM: " << (int)LAntimaterias.size() << endl;
                  }
                  else
                  {
                      itLAM++;
                  }
              }
              cout << "Quantidade de antimatria desalocada: " << cont << endl;
         }
};

// Questo - 5

class Universo
{
  private:
           GrupoEssencias   GE;
           Materia*         pM;
           Antimateria*     pAM;

           static const unsigned int carga_min;
           static const long int carga_max;

  public:
           Universo():
               GE(),
               pM(NULL),
               pAM(NULL)
           {
                criarMaterias();
                criarAntimaterias();
                executar();
           }

           ~Universo()
           {
               pM = NULL;
               pAM = NULL;
               cout << "Destrutora de Universo." << endl;
           }

           void criarMaterias()
           {
               for (int i = 0; i < MAX_MAT; i++)
               {
                   pM = new Materia((short int)i, (5.5 * (float)i) , carga_min);
                   GE.incluirMateria( pM );
               }
               pM = NULL;
           }

           void criarAntimaterias()
           {
               for (int i = 0; i < MAX_ANT; i++)
               {
                   int valor = 0;

                   struct timeval t;
                   gettimeofday(&t,NULL);

                   //srand(time(NULL));
                   srand((int)t.tv_usec);
                   valor = 1 + (int)(rand() % DIV) ;
                   pAM = new Antimateria( (short int) (-1*valor), (float)(-1*valor), carga_max);
                   GE.incluirAntimateria( pAM );
               }
               pAM = NULL;
           }

           void executar()
           {
                GE.confrontarMateriaXAntimateria();
                GE.desalocar();
           }
};

const unsigned int Universo::carga_min = 10000;
const long int Universo::carga_max = -100;

int main ()
{
    Universo U;
    return 0;
}

